<?php

namespace App\Models;

use App\Entities\ProdutoServico\ProdutoServico;

// use const False\MyClass\true;
class ProdutoServicoModel extends ModelEntity {
	protected $table = 'produto_servico';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [
			'nome',
			'descricao',
			'id_tipo',
			'id_status',
			'valor',			
			'criado_por',
			'data_criacao',
			'hora_criacao',
			'alterado_por',	
			'data_alteracao', 
			'hora_alteracao'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = false;

	public function registerProdutoServico(ProdutoServico $tipoExtorno): void {

		$id_new_tipo_extorno = $this->insert( $tipoExtorno->toArray( true ) );
		$tipoExtorno->setId( $id_new_tipo_extorno );

	}

	public function updateProdutoServicoByID(int $id_tipo_extorno, ProdutoServico $tipo_extorno): bool {

		$data = $tipo_extorno->toArray( true );
		$binds = [ 
				'id_produto' => $id_tipo_extorno
		];
		$sets = $this->generateUpdateSets( $data, $binds );
		$sql = "UPDATE produto_servico $sets WHERE produto_servico.id = :id_produto:";
		$query = $this->db->query( $sql, $binds );
		return $query->connID->affected_rows === 1;

	}

}
